> For the complete documentation index, see [llms.txt](https://docs.kaiko.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kaiko.com/kaiko-indices/reference-rates-capital-market/subscribe-futures.md).

# Subscribe - futures

## What is this endpoint for? <a href="#what-is-this-endpoint-for" id="what-is-this-endpoint-for"></a>

Get a live feed / 72-hour replay for any Reference Rate when the "instrument type" is:

* Futures

## Endpoint&#x20;

{% tabs %}
{% tab title="gRPC Stream" %}

```url
gateway.equ.kaiko.io:443 kaiko.equities.EquitiesService/StreamFuturesRates
```

{% endtab %}

{% tab title="gRPC Replay" %}

<pre><code><strong>gateway.equ.kaiko.io:443 kaiko.equities.EquitiesService/ReplayFuturesRates
</strong></code></pre>

{% endtab %}
{% endtabs %}

## Request parameters

{% hint style="info" %}
**Requesting multiple tickers at the same time**\
\
To configure multiple tickers in the same call, provide the  `index_codes` as a comma-separated list, e.g. `["KK_RFR_AAPLUSD", "KK_RFR_TSLAUSD"]` .
{% endhint %}

### Subscribe

<table><thead><tr><th width="184">Parameter</th><th width="377.296875">Description</th><th>Examples</th></tr></thead><tbody><tr><td><code>index_codes</code></td><td>The list of Kaiko Reference Rate ticker. You can find a full list of our tickers <a href="https://www.kaiko.com/indices/reference-rates#table">here</a>.</td><td><code>["KK_RFR_AAPLUSD", "KK_RFR_TSLAUSD"]</code></td></tr></tbody></table>

### Replay

<table><thead><tr><th width="184">Parameter</th><th width="400">Description</th><th>Examples</th></tr></thead><tbody><tr><td><code>index_codes</code></td><td>The list of Kaiko Reference Rate ticker. You can find a full list of our tickers <a href="https://www.kaiko.com/indices/reference-rates#table">here</a>.</td><td><code>KK_RFR_AAPLUSD</code></td></tr><tr><td><code>start_time</code></td><td>Start date of <code>exDate</code> in ISO 8601 (exclusive).</td><td><code>2026-04-22T05:04:32.000Z</code></td></tr><tr><td><code>end_time</code></td><td>Start date of <code>exDate</code> in ISO 8601 (inclusive).</td><td><code>2026-04-22T05:04:33.000Z</code></td></tr></tbody></table>

## Response fields

<table><thead><tr><th width="210">Field</th><th width="537">Description</th></tr></thead><tbody><tr><td><code>indexCode</code></td><td>The list of tickers identifying the rate</td></tr><tr><td><code>price</code></td><td>The value of the rate in the quote denomination</td></tr><tr><td><code>dtFinal</code></td><td>The discounted factor (only applicable for Kaiko Implied Spot Reference rate)</td></tr><tr><td><code>ttm</code></td><td>The time to maturity in seconds (only applicable for Kaiko Implied Spot Reference rate)</td></tr><tr><td><code>timestamp</code></td><td>The exact time of price publication.</td></tr><tr><td><code>startTime</code></td><td>The start time of the data interval</td></tr><tr><td><code>endTime</code></td><td>The end time of the data interval</td></tr><tr><td><code>frontFuture</code></td><td>The details of front future price calculation</td></tr><tr><td>   <mark style="color:$tint;"><code>.symbol</code></mark></td><td>The symbol of the front future in the exchange</td></tr><tr><td>   <mark style="color:$tint;"><code>.price</code></mark></td><td>The calculated price of front future</td></tr><tr><td>   <mark style="color:$tint;"><code>.expiry</code></mark></td><td>The expiry date of front future</td></tr><tr><td>   <mark style="color:$tint;"><code>.weight</code></mark></td><td>The weight in blended future when rollover is proceeding</td></tr><tr><td>   <mark style="color:$tint;"><code>.pairs</code></mark></td><td>The list of pairs combined with additional details included in the computation.</td></tr><tr><td>      <mark style="color:$primary;"><code>.pair</code></mark></td><td>The symbol code - quote asset code(if applicable)</td></tr><tr><td>      <code>.instruments</code></td><td>The different distribution levels included in the price computation.</td></tr><tr><td>         <mark style="color:$tint;"><code>.partition</code></mark></td><td>The sequential number of the partition in calculation</td></tr><tr><td>         <mark style="color:$tint;"><code>.price</code></mark></td><td>The price of the partition</td></tr><tr><td>         <mark style="color:$tint;"><code>.volume</code></mark></td><td>The volume of the partition</td></tr><tr><td>         <mark style="color:$tint;"><code>.count</code></mark></td><td>The number of transaction in the partition</td></tr><tr><td>         <mark style="color:$tint;"><code>.trade</code></mark></td><td>The representative transaction details </td></tr><tr><td>            <code>.exchange</code></td><td>The exchange code</td></tr><tr><td>            <code>.id</code></td><td>The ID of orderbook update</td></tr><tr><td>            <code>.datetime</code></td><td>The datetime of orderbook update</td></tr><tr><td>            <code>.volume</code></td><td>The liquidity weight of the orderbook update</td></tr><tr><td><code>backFuture</code></td><td>The details of back future price calculation. It has identitical structure to the <code>frontFuture</code></td></tr><tr><td><code>spotRate</code></td><td>The details of spot rate that is used to calculated implied spot price</td></tr><tr><td>   <mark style="color:$tint;"><code>.indexCode</code></mark></td><td>The index code of underlying spot rate</td></tr><tr><td>   <mark style="color:$tint;"><code>.price</code></mark></td><td>The price of underlying spot rate</td></tr><tr><td><code>quote</code></td><td>The quote asset code</td></tr><tr><td><code>exchanges</code></td><td>The exchanges involved in the computation. </td></tr><tr><td><code>sequenceId</code></td><td>A unique identifier for the publication.</td></tr><tr><td><code>sessionDetector</code></td><td><p>The status of market session. </p><ul><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_EARLY_HOURS</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_REGULAR_HOURS</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_LATE_HOURS</code></mark></li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_OVERNIGHT</code></mark> </li><li><mark style="color:blue;"><code>INDEX_SESSION_DETECTOR_CLOSED</code></mark></li></ul><p>Please refer to <a href="/pages/5oz054VQbdJFyWJzti4A">Market calendar and trading endpoint</a> for daily session schedule.</p></td></tr></tbody></table>

## Request examples

{% tabs %}
{% tab title="cURL Stream" %}
**cURL requests are intended for testing purposes only.**

{% code overflow="wrap" %}

```url
grpcurl\
      -H "Authorization:Bearer $KAIKO_API_KEY" \
      -emit-defaults \
      -d '{"index_codes":["KK_FRR_HKA50"]}' \
      'gateway.equ.kaiko.io:443' \
      kaiko.equities.EquitiesService.StreamFuturesRates
```

{% endcode %}
{% endtab %}

{% tab title="cURL Replay" %}
**cURL requests are intended for testing purposes only.**

{% code overflow="wrap" %}

```url
grpcurl \
  -H "Authorization: Bearer $KAIKO_API_KEY" \
  -d '{
    "index_codes": ["KK_RFR_TSLAUSD"],
    "start_time":  "2026-04-27T20:04:32.000Z",
    "end_time":    "2026-04-27T20:04:33.000Z"
  }' \
  gateway.equ.kaiko.io:443 \
  kaiko.equities.EquitiesService/ReplayIndex
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Response Example

```json
{
  "indexCode": "KK_FRR_HKA50",
  "price": 2808.067428571429,
  "blendedPrice": 2808.067428571429,
  "dtFinal": 0,
  "ttm": 0,
  "timestamp": "2026-05-20T12:41:21.203067328Z",
  "startTime": "2026-05-20T12:41:06.175348398Z",
  "endTime": "2026-05-20T12:41:21.175348398Z",
  "frontFuture": {
    "symbol": "mcam6",
    "price": 2808.067428571429,
    "expiry": "2026-06-18T00:00:00Z",
    "weight": 1,
    "pairs": [
      {
        "pair": "mcam6",
        "instruments": [
          {
            "partition": "0",
            "price": 2807.9714285714285,
            "volume": 12,
            "count": "4",
            "trade": {
              "exchange": "xhkf",
              "id": "019e4567-34bd-79e3-bc6a-0f0062ee376f",
              "datetime": "2026-05-20T12:40:51.808Z",
              "volume": 3.5
            }
          },
          {
            "partition": "1",
            "price": 2808.04,
            "volume": 7,
            "count": "3",
            "trade": {
              "exchange": "xhkf",
              "id": "019e4567-47df-7e29-b982-db5e0a9cad99",
              "datetime": "2026-05-20T12:40:56.885Z",
              "volume": 2.5
            }
          },
          {
            "partition": "2",
            "price": 2808.1000000000004,
            "volume": 4,
            "count": "2",
            "trade": {
              "exchange": "xhkf",
              "id": "019e4567-4eca-74fb-a351-7b0f8d2c416a",
              "datetime": "2026-05-20T12:40:58.467Z",
              "volume": 2
            }
          },
          {
            "partition": "4",
            "price": 2808.1000000000004,
            "volume": 8.5,
            "count": "4",
            "trade": {
              "exchange": "xhkf",
              "id": "019e4567-624d-7c7a-a8ab-160f2ebbfaaf",
              "datetime": "2026-05-20T12:41:03.467Z",
              "volume": 2
            }
          },
          {
            "partition": "3",
            "price": 2808.04,
            "volume": 13.5,
            "count": "6",
            "trade": {
              "exchange": "xhkf",
              "id": "019e4567-5dbc-7a08-9ce2-9b72c8eaa648",
              "datetime": "2026-05-20T12:41:02.484Z",
              "volume": 2.5
            }
          }
        ]
      }
    ]
  },
  "backFuture": {
    "symbol": "mcan6",
    "price": 0,
    "expiry": "2026-07-17T00:00:00Z",
    "weight": 0,
    "pairs": []
  },
  "spotRate": {
    "indexCode": "",
    "price": 0
  },
  "quote": "usd",
  "exchanges": [
    "xhkf"
  ],
  "sequenceId": "d86qnsdg40ds72t0hebg",
  "sessionDetector": "INDEX_SESSION_DETECTOR_LATE_HOURS"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.kaiko.com/kaiko-indices/reference-rates-capital-market/subscribe-futures.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
